angular.module('focaModalDescarga')
    .factory('focaModalDescargasService', ['$http', 'API_ENDPOINT', 'crearRemitoService',
        function ($http, API_ENDPOINT, crearRemitoService) {
            var route = API_ENDPOINT.URL;
            return {
                crearRemito: function (remito) {
                    return $http.post(route + '/remito/guardar/mobile', remito);
                },
                validarSucursalRemito: function (sucursal, remito) {
                    return $http.get(route + '/remito/validar/' +
                        sucursal + '/' + remito);
                },
                addArticulos: function (articulosRemito, articulosBase, idRemito, cotizacion) {

                    for (var i = 0; i < articulosRemito.length; i++) {

                        var articuloReferencia = articulosBase.filter(function (articulo) {
                            return articulosRemito[i].idArticulo == articulo.id &&
                                parseInt(articulo.cantidad) > 0
                        })[0];
                        if (articuloReferencia === undefined) continue;

                        delete articulosRemito[i].id
                        delete articulosRemito[i].editCantidad;
                        delete articulosRemito[i].editPrecio;

                        articulosRemito[i].idRemito = articulosRemito[i].idRemito !== -1 ?
                            idRemito : articulosRemito[i].idRemito;

                        articulosRemito[i].precio = articuloReferencia.PreVen * cotizacion;
                        articulosRemito[i].cantidad = articuloReferencia.cantidad;
                        articulosRemito[i].cantidadDescargada = articuloReferencia.cantidad;

                        delete articulosRemito[i].idNotaPedido;
                        crearRemitoService.crearArticulosParaRemito(articulosRemito[i]);
                    }
                }
            };
        }]);
